--- SandBar.py	2012-06-15 23:10:42.000000000 -0500
+++ SandBarMoreIslands.py	2012-06-29 02:08:07.000000000 -0500
@@ -1,5 +1,14 @@
 ##############################################################################
-## File: SandBar.py version 20120612 (June 12, 2012)
+## File: SandBarMoreIslands.py version 20120629 (June 29, 2012)
+##
+## This is like SandBar.py (very desert map, ideal for Legends of Ancient
+## Arabia or other desert-themed mods, or a very dry Civ4 experience), but
+## there will usually be more islands off of the mainland to explore, and 
+## the mainland will be a little smaller.
+##
+## The map will still (usually) have a single big mainland, but now it will
+## have a few smaller islands to expore with Dhows (Caravels) in the midgame
+##
 ## Original file: PerfectWorld.py version 2.06
 ## Author: Rich Marinaccio
 ## Modified by Sam Trenholme; I am assigning all copyright to Rich
@@ -52,6 +61,8 @@
 ## Arabian mods (Legends of Ancients Arabia, Rhye's and Fall: 
 ## The Sword of Islam, Crossroads of the World, etc.)
 ##
+## 20120629: Hack to add a few more islands
+##
 ## 20120612: 
 ## 1) Made map more Arabia-like: Much bigger tropics, more dry, no snowy peaks
 ##    fewer map options, flat square map with roundish island on it which will
@@ -558,7 +569,7 @@
 	seaLevel = 0 # Arab: Force high sea level
         self.landPercent = 0.43
         if seaLevel == 0:
-            self.landPercent = 0.65 # ARAB SEA LEVEL
+            self.landPercent = 0.47 # ARAB SEA LEVEL
         elif seaLevel == 2:
             self.landPercent = 0.29
 
@@ -1453,7 +1464,7 @@
             i = GetHmIndex(x,y)
             self.heightMap[i] = 1.0
         
-	self.rotateMap(0.8) # LETS HAVE FUN 
+	self.rotateMap(0.9) # LETS HAVE FUN 
         self.printInitialPeaks()
 
         #Now use a diamond-square algorithm(sort of) to generate the rest
@@ -1756,7 +1767,6 @@
 	low = 0
 	min = 10000.0
 
-
 	# Find the place on the map with the most water (lowest heightfield)
         for x in range(mc.hmWidth):
 		sum = 0.0
@@ -1777,6 +1787,29 @@
 			self.heightMap[GetHmIndex(x,y)] = tempStripe[
 				((x + low) % mc.hmWidth)]
 
+	# Vertical rotate
+	low = 0
+	min = 10000.0
+	# Find the place on the map with the most water (lowest heightfield)
+        for y in range(mc.hmHeight):
+		sum = 0.0
+		for x in range(mc.hmWidth):
+			sum += self.heightMap[GetHmIndex(x,y)]
+		#print "for x %d sum is %f min %f" % (x,sum,min)
+		if(sum < min):
+			low = y
+			min = sum
+	#print "low x is %d" % (low) #DEBUG
+	
+	# Rotate the height map so we wrap where there is more water
+	for x in range(mc.hmWidth):
+		tempStripe = []
+		for y in range(mc.hmHeight):
+			tempStripe.append(self.heightMap[GetHmIndex(x,y)])
+		for y in range(mc.hmHeight):
+			self.heightMap[GetHmIndex(x,y)] = tempStripe[
+				((y + low) % mc.hmHeight)]
+
 	# Lower the height map near the poles, since it looks weird in
 	# Arabian maps. Also remove land near map edge (again, weird)
 	# on square maps
@@ -5737,15 +5770,15 @@
     hm.performTectonics()
     hm.generateHeightMap()
     hm.combineMaps()
-    hm.rotateMap(0.8) # Once
+    hm.rotateMap(0.9) # Once
     hm.calculateSeaLevel()
     hm.fillInLakes()
     pb.breakPangaeas()
 ##    hm.Erode()
 ##    hm.printHeightMap()
-    hm.rotateMap(0.6) # Again
-    hm.calculateSeaLevel() # This also again
     hm.rotateMap(0.8) # Again
+    hm.calculateSeaLevel() # This also again
+    hm.rotateMap(0.9) # Again
     hm.addWaterBands()
 ##    hm.printHeightMap()
     cm.createClimateMaps()
